<html>
<head>
<title>OgreRenderToVertexBuffer.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreRenderToVertexBuffer.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreRenderToVertexBuffer_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __RenderToVertexBuffer_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __RenderToVertexBuffer_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreMaterial_8h.html">OgreMaterial.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreRenderOperation_8h.html">OgreRenderOperation.h</a>&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="keyword">namespace </span>Ogre {
<a name="l00051"></a><a class="code" href="classOgre_1_1RenderToVertexBuffer.html">00051</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1RenderToVertexBuffer.html" title="An object which renders geometry to a vertex.">RenderToVertexBuffer</a>
<a name="l00052"></a>00052     {    
<a name="l00053"></a>00053     <span class="keyword">public</span>:
<a name="l00055"></a>00055         <a class="code" href="classOgre_1_1RenderToVertexBuffer.html" title="An object which renders geometry to a vertex.">RenderToVertexBuffer</a>();
<a name="l00057"></a>00057         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1RenderToVertexBuffer.html" title="An object which renders geometry to a vertex.">RenderToVertexBuffer</a>();
<a name="l00058"></a>00058 
<a name="l00065"></a>00065         <a class="code" href="classOgre_1_1VertexDeclaration.html" title="This class declares the format of a set of vertex inputs, which can be issued to the rendering API th...">VertexDeclaration</a>* getVertexDeclaration();
<a name="l00066"></a>00066         
<a name="l00070"></a><a class="code" href="classOgre_1_1RenderToVertexBuffer.html#a883622495c6c19c55b34cbb2cbc83cac">00070</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classOgre_1_1RenderToVertexBuffer.html#a883622495c6c19c55b34cbb2cbc83cac" title="Get the maximum number of vertices that the buffer will hold.">getMaxVertexCount</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mMaxVertexCount; }
<a name="l00071"></a>00071         
<a name="l00075"></a><a class="code" href="classOgre_1_1RenderToVertexBuffer.html#a2db0eaaf24eb8de2427e5a33a923544b">00075</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1RenderToVertexBuffer.html#a2db0eaaf24eb8de2427e5a33a923544b" title="Set the maximum number of vertices that the buffer will hold.">setMaxVertexCount</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> maxVertexCount) { mMaxVertexCount = maxVertexCount; }
<a name="l00076"></a>00076 
<a name="l00080"></a><a class="code" href="classOgre_1_1RenderToVertexBuffer.html#a8ace11d57f754588746a86c6dea6dc48">00080</a>         <a class="code" href="classOgre_1_1RenderOperation.html#a7a272218dae54048c87f31176c19e10d" title="The rendering operation type to perform.">RenderOperation::OperationType</a> <a class="code" href="classOgre_1_1RenderToVertexBuffer.html#a8ace11d57f754588746a86c6dea6dc48" title="What type of primitives does this object generate?">getOperationType</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mOperationType; }
<a name="l00081"></a>00081 
<a name="l00085"></a><a class="code" href="classOgre_1_1RenderToVertexBuffer.html#a3a23fc7f800fcd9014919ff977e55905">00085</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1RenderToVertexBuffer.html#a3a23fc7f800fcd9014919ff977e55905" title="Set the type of primitives that this object generates.">setOperationType</a>(<a class="code" href="classOgre_1_1RenderOperation.html#a7a272218dae54048c87f31176c19e10d" title="The rendering operation type to perform.">RenderOperation::OperationType</a> operationType) { mOperationType = operationType; }
<a name="l00086"></a>00086 
<a name="l00090"></a><a class="code" href="classOgre_1_1RenderToVertexBuffer.html#aa6b992fb1f1f4098edb85c782b860f24">00090</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1RenderToVertexBuffer.html#aa6b992fb1f1f4098edb85c782b860f24" title="Set wether this object resets its buffers each time it updates.">setResetsEveryUpdate</a>(<span class="keywordtype">bool</span> resetsEveryUpdate) { mResetsEveryUpdate = resetsEveryUpdate; }
<a name="l00091"></a>00091 
<a name="l00095"></a><a class="code" href="classOgre_1_1RenderToVertexBuffer.html#a5c9e4cc0e644416d3754aaa0e12f4bd8">00095</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1RenderToVertexBuffer.html#a5c9e4cc0e644416d3754aaa0e12f4bd8" title="Does this object reset its buffer each time it updates?">getResetsEveryUpdate</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mResetsEveryUpdate; }
<a name="l00096"></a>00096 
<a name="l00100"></a>00100         <span class="keyword">virtual</span> <span class="keywordtype">void</span> getRenderOperation(<a class="code" href="classOgre_1_1RenderOperation.html" title="&#39;New&#39; rendering operation using vertex buffers.">RenderOperation</a>&amp; op) = 0;
<a name="l00101"></a>00101 
<a name="l00105"></a>00105         <span class="keyword">virtual</span> <span class="keywordtype">void</span> update(<a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a>* sceneMgr) = 0;
<a name="l00106"></a>00106 
<a name="l00111"></a><a class="code" href="classOgre_1_1RenderToVertexBuffer.html#a276cd906b96a46a596d7f0abdf122302">00111</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1RenderToVertexBuffer.html#a276cd906b96a46a596d7f0abdf122302" title="Reset the vertex buffer to the initial state.">reset</a>() { mResetRequested = <span class="keyword">true</span>; }
<a name="l00112"></a>00112         
<a name="l00118"></a><a class="code" href="classOgre_1_1RenderToVertexBuffer.html#a1ac41c57f4cb8c493dfedca2d83692ca">00118</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1RenderToVertexBuffer.html#a1ac41c57f4cb8c493dfedca2d83692ca" title="Set the source renderable of this object.">setSourceRenderable</a>(<a class="code" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a>* source) { mSourceRenderable = source; }
<a name="l00119"></a>00119 
<a name="l00123"></a><a class="code" href="classOgre_1_1RenderToVertexBuffer.html#a38890b3ad14b32428d57520fdec9e48b">00123</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a>* <a class="code" href="classOgre_1_1RenderToVertexBuffer.html#a38890b3ad14b32428d57520fdec9e48b" title="Get the source renderable of this object.">getSourceRenderable</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mSourceRenderable; }
<a name="l00124"></a>00124 
<a name="l00129"></a><a class="code" href="classOgre_1_1RenderToVertexBuffer.html#a6c530df86894044d524825e0be11fe33">00129</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a>&amp; <a class="code" href="classOgre_1_1RenderToVertexBuffer.html#a6c530df86894044d524825e0be11fe33" title="Get the material which is used to render the geometry into the vertex buffer.">getRenderToBufferMaterial</a>() { <span class="keywordflow">return</span> mMaterial; }
<a name="l00130"></a>00130 
<a name="l00135"></a>00135         <span class="keywordtype">void</span> setRenderToBufferMaterialName(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; materialName);
<a name="l00136"></a>00136     <span class="keyword">protected</span>:
<a name="l00137"></a><a class="code" href="classOgre_1_1RenderToVertexBuffer.html#ab9071935eb9ab1effbc8e6358ba38a67">00137</a>         <a class="code" href="classOgre_1_1RenderOperation.html#a7a272218dae54048c87f31176c19e10d" title="The rendering operation type to perform.">RenderOperation::OperationType</a> <a class="code" href="classOgre_1_1RenderToVertexBuffer.html#ab9071935eb9ab1effbc8e6358ba38a67">mOperationType</a>;
<a name="l00138"></a><a class="code" href="classOgre_1_1RenderToVertexBuffer.html#aa7b0315836d1753e0ee1938d55cc7f93">00138</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1RenderToVertexBuffer.html#aa7b0315836d1753e0ee1938d55cc7f93">mResetsEveryUpdate</a>;
<a name="l00139"></a><a class="code" href="classOgre_1_1RenderToVertexBuffer.html#a69b7fe4c1730c47978aa497deb42f22e">00139</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1RenderToVertexBuffer.html#a69b7fe4c1730c47978aa497deb42f22e">mResetRequested</a>;
<a name="l00140"></a><a class="code" href="classOgre_1_1RenderToVertexBuffer.html#a95a4702c70c3fe0fd2313c836c8e4dbe">00140</a>         <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a> <a class="code" href="classOgre_1_1RenderToVertexBuffer.html#a95a4702c70c3fe0fd2313c836c8e4dbe">mMaterial</a>;
<a name="l00141"></a><a class="code" href="classOgre_1_1RenderToVertexBuffer.html#a281d1d81160af52e32be61cf5f27cf70">00141</a>         <a class="code" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a>* <a class="code" href="classOgre_1_1RenderToVertexBuffer.html#a281d1d81160af52e32be61cf5f27cf70">mSourceRenderable</a>;
<a name="l00142"></a><a class="code" href="classOgre_1_1RenderToVertexBuffer.html#a21c5d5d9ec70314f9727553b6dd0faf2">00142</a>         <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>* <a class="code" href="classOgre_1_1RenderToVertexBuffer.html#a21c5d5d9ec70314f9727553b6dd0faf2">mVertexData</a>;
<a name="l00143"></a><a class="code" href="classOgre_1_1RenderToVertexBuffer.html#a0b626515d04c2216f2d987b45925794e">00143</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classOgre_1_1RenderToVertexBuffer.html#a0b626515d04c2216f2d987b45925794e">mMaxVertexCount</a>;
<a name="l00144"></a>00144     };
<a name="l00145"></a>00145 
<a name="l00146"></a><a class="code" href="group__RenderSystem.html#ga00531851f476b9a8432258652828902a">00146</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr&lt;RenderToVertexBuffer&gt;</a> <a class="code" href="group__RenderSystem.html#ga00531851f476b9a8432258652828902a">RenderToVertexBufferSharedPtr</a>;
<a name="l00149"></a>00149 }
<a name="l00150"></a>00150 
<a name="l00151"></a>00151 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:51
</p>
</body>
</html>
